import java.awt.*;
import java.io.*;
import java.applet.*;
import java.lang.*;
import java.net.*;
import java.util.*;
import java.awt.event.*;
import java.awt.datatransfer.*;

/* Ex Package */
import javax.comm.*;

public class modem extends Applet implements Runnable,WindowListener,ActionListener,ClipboardOwner{
    static String ver = "v1.11";

    Frame main_frame=null;
    CarrierFrame carrier_frame=null;
    ErrorFrame err_frame=null;
    CmdFrame cmd_frame=null;

    Clipboard clipboard = getToolkit().getSystemClipboard();

    MenuItem Connect,Disconnect,Suspend,Resume,Stop,Start,Save,Close,
             Setting,Prefer,Copy,
             Analysis,ErrDetail,CmdInput,
             BspDownUp,Restart,IpDisable;

    Label mlabel[];
    TextField mtext[], sts;
    TextArea syslog;

    boolean autorun=false;

    boolean tcp_init = true;

// serial port, socket, io stream
    SerialPort port=null;
    Socket sock=null;
    InputStream is=null;
    OutputStream os=null;

// thread
    Thread th=null;
    boolean status_flg=true;  // child set, parent read
    boolean suspend_flg=false; // child read, parent set

// Modem Version
    int ModemVer = 0;
    int NewVer = 300;

// settings
    SettingInfo si;
    PreferInfo pi;
    String pwd_prompt = "PASSWORD:";
    String syslog_file = "event.log";

    public static void main(String[] args){
        boolean flg=false;

        Frame f = new Frame("Modem Telemeter "+ver+" - Overall Information");
        if(args.length>0) flg=true;
        modem md = new modem(f,flg);
        md.init();
        md.start();
    }

    public modem(Frame f, boolean flg){
        main_frame = f;
        main_frame.addWindowListener(this);
        autorun = flg;
    }

    public void init(){
        Point pt;
        Toolkit tk = Toolkit.getDefaultToolkit();

        set_menu();
        create_main_frame();
        main_frame.add("Center",this);
        main_frame.pack();
        main_frame.setVisible(true);

        pt = main_frame.getLocationOnScreen();
        carrier_frame = new CarrierFrame(main_frame, "Analysis");
        carrier_frame.setLocation(
                 tk.getScreenSize().width - carrier_frame.getSize().width,
                 tk.getScreenSize().height - carrier_frame.getSize().height
        );
        err_frame = new ErrorFrame(main_frame, "Error Detail Info");
        err_frame.setLocation(pt.x+getSize().width, pt.y);

        if(autorun) connect_modem();
    }

    public void set_menu(){
        MenuBar mb=new MenuBar();
        main_frame.setMenuBar(mb);
        Menu mfile = new Menu("File");
        Menu medit = new Menu("Edit");
        Menu mwindow = new Menu("Window");
        Menu mcmd = new Menu("Command");

        mb.add(mfile);mb.add(medit);mb.add(mwindow);mb.add(mcmd);

        Connect = new MenuItem("Connect");mfile.add(Connect);
        Disconnect = new MenuItem("Disconnect");mfile.add(Disconnect);
        Suspend = new MenuItem("Suspend");mfile.add(Suspend);
        Resume = new MenuItem("Resume");mfile.add(Resume);
        Stop = new MenuItem("Stop");mfile.add(Stop);
        Start = new MenuItem("Start");mfile.add(Start);
        Save = new MenuItem("Save");mfile.add(Save);
        Close = new MenuItem("Close");mfile.add(Close);

        Setting = new MenuItem("Setting");medit.add(Setting);
        Prefer = new MenuItem("Preference");medit.add(Prefer);
        Copy = new MenuItem("Copy");medit.add(Copy);

        Analysis = new MenuItem("Analysis");mwindow.add(Analysis);
        ErrDetail = new MenuItem("Error Details");mwindow.add(ErrDetail);
        CmdInput = new MenuItem("Command Input");mwindow.add(CmdInput);

        BspDownUp = new MenuItem("bsp down/up");mcmd.add(BspDownUp);
        Restart = new MenuItem("restart");mcmd.add(Restart);
        IpDisable = new MenuItem("ip disable etherb");mcmd.add(IpDisable);

        Connect.addActionListener(this);
        Disconnect.addActionListener(this);
        Suspend.addActionListener(this);
        Resume.addActionListener(this);
        Stop.addActionListener(this);
        Start.addActionListener(this);
        Save.addActionListener(this);
        Close.addActionListener(this);
        Setting.addActionListener(this);
        Prefer.addActionListener(this);
        Copy.addActionListener(this);
        Analysis.addActionListener(this);
        ErrDetail.addActionListener(this);
        CmdInput.addActionListener(this);
        BspDownUp.addActionListener(this);
        Restart.addActionListener(this);
        IpDisable.addActionListener(this);

        Connect.setEnabled(true);
        Disconnect.setEnabled(false);
        Suspend.setEnabled(false);
        Resume.setEnabled(false);
        Stop.setEnabled(false);
        Start.setEnabled(false);
    }

    public void create_main_frame(){
        Panel center;
        Panel south;
        Panel tmp;
        int i,j;

        setLayout(new BorderLayout());
        setBackground(Color.pink); //main_frame.setBackground(Color.pink);
        setForeground(Color.black);  //main_frame.setForeground(Color.pink);

        center = new Panel();
        center.setLayout(new GridLayout(9,3));
        mlabel = new Label[8];
        for(i=0;i<8;i++) mlabel[i] = new Label();
        mlabel[0].setText("Fast Channel");
        mlabel[1].setText("Interleaved Channel");
        mlabel[2].setText("Capacity Occupation");
        mlabel[3].setText("Noise Margin");
        mlabel[4].setText("Attenuation");
        mlabel[5].setText("Output Power");
        mlabel[6].setText("Carrier Load");
        mlabel[7].setText("Error");
        mtext = new TextField[16];
        for(i=0;i<16;i++){
           mtext[i]  = new TextField();
           mtext[i].setEditable(false);
           mtext[i].setBackground(getBackground());
           mtext[i].setForeground(getForeground());
        }
        center.add(new Label("Current Status"),0);center.add(new Label("Downstream"),1);center.add(new Label("Upstream"),2);
        j=3;
        for(i=0;i<8;i++){
           center.add(mlabel[i],j); j++;
           center.add(mtext[2*i],j); j++;
           center.add(mtext[2*i+1],j);j++;
        }

        south = new Panel();
        south.setLayout(new BorderLayout());
        south.add("Center",syslog=new TextArea(3,20)); syslog.setEditable(false);
        syslog.setBackground(getBackground());
        syslog.setForeground(getForeground());
        tmp = new Panel();
        tmp.setLayout(new FlowLayout(FlowLayout.LEFT,2,2));
        tmp.add(new Label("Status"));
        tmp.add(sts=new TextField(40)); sts.setEditable(false);
        sts.setBackground(getBackground());
        sts.setForeground(getForeground());
        south.add("South",tmp);

        add("Center",center);
        add("South",south);
    }

    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();

// File menu
        if(cmd.equals(Connect.getActionCommand())){
            connect_modem();
        }
        else if(cmd.equals(Disconnect.getActionCommand())){
            disconnect_modem();
        }
        else if(cmd.equals(Suspend.getActionCommand())){
            suspend_child();
        }
        else if(cmd.equals(Resume.getActionCommand())){
            if(cmd_frame!=null&&cmd_frame.isShowing()){
                NoticeDialog dia = new NoticeDialog(
                     main_frame,"You must close Command Input before Resume","",true);
                return;
            }
            resume_child();
        }
        else if(cmd.equals(Stop.getActionCommand())){
            if(si.isTcpip()){
                NoticeDialog dia = new NoticeDialog(
                     main_frame,"You cannot STOP with TCP connection","Discconect the connection and then connect again",true);
                return;
            }
            th.stop(); th=null;
            Connect.setEnabled(false);
            Disconnect.setEnabled(true);
            Suspend.setEnabled(false);
            Resume.setEnabled(false);
            Stop.setEnabled(false);
            Start.setEnabled(true);
            set_status("Monitor thread is stopped now");
        }
        else if(cmd.equals(Start.getActionCommand())){
            if(cmd_frame!=null&&cmd_frame.isShowing()){
                NoticeDialog dia = new NoticeDialog(
                     main_frame,"You must close Command Input before Start","",true);
                return;
            }
            start_child();
        }
        else if(cmd.equals(Save.getActionCommand())){
            save();
        }
        else if(cmd.equals(Close.getActionCommand())){
            System.exit(0);
        }
// Edit menu
        else if(cmd.equals(Setting.getActionCommand())){
            SettingDialog sdia = new SettingDialog(main_frame,"Settings...");
        }
        else if(cmd.equals(Prefer.getActionCommand())){
            PreferDialog pdia = new PreferDialog(main_frame,"Preference...");
        }
        else if(cmd.equals(Copy.getActionCommand())){
            String srcData = copy();
            StringSelection contents = new StringSelection(srcData);
            clipboard.setContents(contents, this);
        }
// Window menu
        else if(cmd.equals(Analysis.getActionCommand())){
            carrier_frame.show();
        }
        else if(cmd.equals(ErrDetail.getActionCommand())){
            err_frame.show();
        }
        else if(cmd.equals(CmdInput.getActionCommand())){
            if(cmd_frame!=null&&cmd_frame.isShowing()){
                NoticeDialog dia = new NoticeDialog(
                     main_frame,"You have already opened Command Input","Before open new, close the old one",true);
                return;
            }
            if(th==null || suspend_child()){
                cmd_frame = new CmdFrame(this, "Command Input");
                cmd_frame.setLocation(50,50);
                cmd_frame.show();
            }
        }
// Command menu
        else if(cmd.equals(BspDownUp.getActionCommand())){
            if(suspend_child()){
                 if(exec_cmd("bsp down")){
                      if(si.isSerial()||ModemVer>=NewVer) {
                          String line;
                          while(true){
                              line = readLine(is);
                              if(line.indexOf("IDLE")>=0) break;
                          }
                      }
                      try{
                         Thread.currentThread().sleep(pi.getDownupInt()*1000);
                      }
                      catch(Exception ee){}
                      if(send_cmd("bsp up"))
                          modem_status_chk("Modem is NOT in SHOWTIME yet");
                      else {
                          NoticeDialog dia = new NoticeDialog(
                     main_frame,"Fail to exec bsp up","Line maybe down. Try restart command",true);
                      }
                 }
                 resume_child();
            }
        }
        else if(cmd.equals(Restart.getActionCommand())){
            if(suspend_child()){
               if(send_cmd("restart"))
                  set_syslog("Exec restart...Reboot");
               resume_child();
            }
        }
        else if(cmd.equals(IpDisable.getActionCommand()) ){
            if(suspend_child()){
               if(exec_cmd(cmd))
                   set_syslog("Exec ip disable");
               else
                   set_syslog("Fail to exec ip disable");
               resume_child();
            }
        }
    }

    public void connect_modem(){
        si = new SettingInfo();
        pi = new PreferInfo();

        if(cmd_frame!=null&&cmd_frame.isShowing()){
            NoticeDialog dia = new NoticeDialog(
                 main_frame,"You must close Command Input before Connect","",true);
            return;
        }
        if(si.isSerial()&&!open_serialport())
            return;
        suspend_flg = false;
        th = new Thread(this); th.start();
        Connect.setEnabled(false);
        Disconnect.setEnabled(true);
        Suspend.setEnabled(true);
        Resume.setEnabled(false);
        Stop.setEnabled(true);
        Start.setEnabled(false);
        set_status("Connect to the modem");
        set_syslog("Connect to the modem");
    }

    public void disconnect_modem(){
        try{
            Connect.setEnabled(true);
            Disconnect.setEnabled(false);
            Suspend.setEnabled(false);
            Resume.setEnabled(false);
            Stop.setEnabled(false);
            Start.setEnabled(false);
            set_status("Disconnected");
            set_syslog("Disconnected");
            if(th!=null&&th.isAlive()) th.stop();
            if(is!=null) is.close();
            if(os!=null) os.close();
            if(port!=null) port.close();
            if(sock!=null) sock.close();
            is=null;os=null;port=null;sock=null;th=null;
        }
        catch(Exception ee){
            NoticeDialog dia = new NoticeDialog(
                 main_frame,"Fail to disconnect, shutdown this program and restart again ", ee.toString(),true);
        }
    }

    public void windowOpened(WindowEvent e){
    }
    public void windowClosing(WindowEvent e){
        ConfirmDialog dia = new ConfirmDialog(main_frame,"Do you really want to exit?");
        if(dia.get_status())
           System.exit(0);
    }
    public void windowClosed(WindowEvent e){
    }
    public void windowIconified(WindowEvent e){
    }
    public void windowDeiconified(WindowEvent e){
    }
    public void windowActivated(WindowEvent e){
    }
    public void windowDeactivated(WindowEvent e){
    }

    public void lostOwnership(Clipboard clipboard, Transferable contents) {
    }

    public boolean suspend_child(){
        int i=0;
        String s="";

        set_status("Try to suspend");
        suspend_flg = true;
        while(status_flg){
            try{
                Thread.currentThread().sleep(1000);
            }
            catch(Exception e){
                break;
            }
            s = s+"."; set_status(s);
            i++;
            if(i==10){
                th.suspend();
                ConfirmDialog cdia = new ConfirmDialog(main_frame,"Cannot suspend within 10 seconds. Continue?");
                th.resume();
                if(!cdia.get_status()){
                    break;
                }
                else{
                    i=0;
                    s="";
                }
            }
        }
        if(!status_flg){
//            th.suspend();
            set_status("Monitor thread is suspended now");
            Connect.setEnabled(false);
            Disconnect.setEnabled(true);
            Suspend.setEnabled(false);
            Resume.setEnabled(true);
            Stop.setEnabled(true);
            Start.setEnabled(false);
            return true;
        }
        else{
            suspend_flg=false;
            NoticeDialog dia = new NoticeDialog(main_frame,"Fail to suspend","Try to STOP or shutdown program",true);
            return false;
        }
    }

    public boolean resume_child(){
        int i;
        String s="";

        suspend_flg = false;
        th.resume();
        i=0;
        while(!status_flg){
            try{
                Thread.currentThread().sleep(1000);
            }
            catch(Exception e){break;}
            s = s+"."; set_status(s);
            i++;
            if(i==10){
                ConfirmDialog cdia = new ConfirmDialog(main_frame,"Cannot resume within 10 seconds. Continue?");
                if(!cdia.get_status()){
                    break;
                }
                else{
                    i=0;
                    s="";
                }
            }
        }
        if(status_flg){
            set_status("Monitor thread is resumed");
            Connect.setEnabled(false);
            Disconnect.setEnabled(true);
            Suspend.setEnabled(true);
            Resume.setEnabled(false);
            Stop.setEnabled(true);
            Start.setEnabled(false);
            return true;
        }
        else{
            suspend_flg=false;
            NoticeDialog dia = new NoticeDialog(main_frame,"Fail to resume","Try to START or shutdown program",true);
            return false;
        }
    }

    public void start_child(){
        set_status("Monitor thread is starting now");
        suspend_flg = false;
        th = new Thread(this); th.start();
        Connect.setEnabled(false);
        Disconnect.setEnabled(true);
        Suspend.setEnabled(true);
        Resume.setEnabled(false);
        Stop.setEnabled(true);
        Start.setEnabled(false);
    }

    public boolean exec_cmd(String s){
        String line;

        if(!send_cmd(s)) {
            NoticeDialog dia = new NoticeDialog(main_frame,"Fail to exec "+s,"Try again or shutdown program",true);
            return false;
        }
        while((line=readLine(is))!=null && !line.endsWith("> "));
        return true;
    }

    public boolean open_serialport(){
        CommPortIdentifier comm;

        try{
            comm = CommPortIdentifier.getPortIdentifier(si.getPort());
            port = (SerialPort)comm.open("modem monitor",2000);
            port.setSerialPortParams(9600,
                SerialPort.DATABITS_8,
                SerialPort.STOPBITS_1,
                SerialPort.PARITY_NONE);
            is = port.getInputStream();
            os = port.getOutputStream();
        }
        catch(Exception e){
            NoticeDialog dia = new NoticeDialog(main_frame,"Fail to open "+si.getPort(), e.toString(),true);
            return false;
        }
        return true;
    }

    public boolean open_tcpip(){
        while(true){
            try{
                if(sock!=null) sock.close();
                if(is!=null) is.close();
                if(os!=null) os.close();
            }
            catch(Exception e){}
            try{
                set_status("Try to connect "+si.getIpaddr());
                sock = new Socket(si.getIpaddr(),23);
                sock.setSoTimeout(10*1000);
                is = sock.getInputStream();
                os = sock.getOutputStream();
                readLine(is);   // password prompt
                if(!send_pwd()) return false;
                tcp_init = false;
                break;
            }
            catch(Exception e){
                if(tcp_init){
                    NoticeDialog dia = new NoticeDialog(main_frame,"Fail to connect "+si.getIpaddr(), e.toString(),true);
                    set_status("Fail to connect to "+si.getIpaddr());
                    return false;
                }
                try{
                    Thread.currentThread().sleep(10*1000);
                }
                catch(Exception ee){}
            }
        }
        return true;
    }

    public void run(){
        while(true){
            if(si.isTcpip()&&!open_tcpip())
                return;
            set_status("Running @init_modem");
            if(!init_modem()) break;
            if(!get_version()) break;
            while(true){
                set_status("Running @bsp channel");
                if(!bsp_channel()) break;
                suspend_chk();
                set_status("Running @bsp line");
                if(!bsp_line()) break;
                suspend_chk();
                set_status("Running @bsp perf");
                if(!bsp_perf()) break;
                suspend_chk();
            }
            set_syslog("Connection reset");
            set_status("Connection reset");
            save_current_status();
        }
    }

    public void suspend_chk(){
        int i;
        int loop = pi.getLoopInt();

        if(loop<=0) loop=1;
        for(i=0;i<loop;i++){
            if(suspend_flg){
                    set_syslog("Suspend...sleep");
                    status_flg = false;
                    Thread.currentThread().suspend();
                    status_flg = true;
                    set_syslog("Wake up and Resume");
                    break;
            }
            if(pi.getLoopInt()==0) break;
            try{
                Thread.currentThread().sleep(1000);
            }
            catch(Exception e){}
        }
    }

    public boolean bsp_channel(){
        String line;
        try{
            if(!send_cmd("bsp channel")) return false;
            while(true){
               if((line=readLine(is))==null) return false;
               if(line.indexOf("NEAR END FAST CHANNEL")>=0)
                    settext(0,line);
               else if(line.indexOf("FAR END FAST CHANNEL")>=0)
                    settext(1,line);
               else if(line.indexOf("NEAR END INTERLEAVED CHANNEL")>=0)
                    settext(2,line);
               else if(line.indexOf("FAR END INTERLEAVED CHANNEL")>=0)
                    settext(3,line);
               else if(line.endsWith("> "))
                    break;
               else if(!modem_status_chk(line))
                    break;
            }
        }
        catch(Exception e){
            return false;
        }
        return true;
    }

    public boolean bsp_line(){
        String load, line, last;
        boolean flg;
        int b[];
        int i,num;

        try{
            if(!send_cmd("bsp line")) return false;
            while(true){
               if((line=readLine(is))==null) return false;
               if(line.startsWith("Downstream Capacity Occupation"))
                    settext(4,line);
               else if(line.startsWith("Upstream Capacity Occupation"))
                    settext(5,line);
               else if(line.startsWith("Downstream Noise Margin"))
                    settext(6,line);
               else if(line.startsWith("Upstream Noise Margin"))
                    settext(7,line);
               else if(line.startsWith("Downstream Attenuation"))
                    settext(8,line);
               else if(line.startsWith("Upstream Attenuation"))
                    settext(9,line);
               else if(line.startsWith("Downstream Output Power"))
                    settext(10,line);
               else if(line.startsWith("Upstream Output Power"))
                    settext(11,line);
               else if(line.startsWith("Carrier Load")){
                  load = "";
                  flg = true;
                  while((line=readLine(is))!=null && !line.endsWith("> ") && (flg=modem_status_chk(line)))
                      load = load+line+"\n";
                  if(!flg) break;
                  if((b=getarray(load))==null) break;
                  num = 0;
                  for(i=0;i<32;i++) num += b[i];
                  settext(13,String.valueOf(num));
                  num = 0;
                  for(i=32;i<256;i++) num += b[i];
                  settext(12,String.valueOf(num));
                  last =carrier_frame.gettext();
                  if(last!=null && !last.equals(load)){
                      carrier_frame.settext(load);
                  }
                  break;
               }
               else if(!modem_status_chk(line))
                    break;
            }
        }
        catch(Exception e){
            return false;
        }
        return true;
    }

    public boolean bsp_perf(){
        String line;
        boolean nearend=true, fast=true, stsflg;
        int nearend_err=0, farend_err=0, num;

        try{
            if(!send_cmd("bsp perf")) return false;
            stsflg = true;
            while(true){
               if((line=readLine(is))==null) return false;
               if(line.indexOf("NEAR END")>=0)
                    nearend = true;
               else if(line.indexOf("FAR END")>=0)
                    nearend = false;
               else if(line.indexOf("FAST CHANNEL")>=0)
                    fast = true;
               else if(line.indexOf("INTERLEAVED CHANNEL")>=0)
                    fast = false;
/*
    TextField dl_fec, dl_crc, dl_hec, dl_inter_fec, dl_inter_crc, dl_inter_hec,
              up_fec, up_crc, up_hec, up_inter_fec, up_inter_crc, up_inter_hec;
    ErrorFrame err_frame;
*/
               else if(line.indexOf("FEC")>=0||line.indexOf("CRC")>=0||line.indexOf("HEC")>=0){
                    if(nearend) nearend_err += Integer.parseInt(decompose(line));
                    else  farend_err += Integer.parseInt(decompose(line));
                    if(line.indexOf("FEC")>=0){
                        if(nearend&&fast)        err_frame.dl_fec.setText(decompose(line));
                        else if(nearend&&!fast)  err_frame.dl_inter_fec.setText(decompose(line));
                        else if(!nearend&&fast)  err_frame.up_fec.setText(decompose(line));
                        else if(!nearend&&!fast) err_frame.up_inter_fec.setText(decompose(line));
                    }
                    else if(line.indexOf("CRC")>=0){
                        if(nearend&&fast)        err_frame.dl_crc.setText(decompose(line));
                        else if(nearend&&!fast)  err_frame.dl_inter_crc.setText(decompose(line));
                        else if(!nearend&&fast)  err_frame.up_crc.setText(decompose(line));
                        else if(!nearend&&!fast) err_frame.up_inter_crc.setText(decompose(line));
                    }
                    else if(line.indexOf("HEC")>=0){
                        if(nearend&&fast)        err_frame.dl_hec.setText(decompose(line));
                        else if(nearend&&!fast)  err_frame.dl_inter_hec.setText(decompose(line));
                        else if(!nearend&&fast)  err_frame.up_hec.setText(decompose(line));
                        else if(!nearend&&!fast) err_frame.up_inter_hec.setText(decompose(line));
                    }
               }
               else if(line.endsWith("> "))
                    break;
               else if(!(stsflg=modem_status_chk(line)))
                    break;
            }
            if(stsflg){
               settext(14,String.valueOf(nearend_err));
               settext(15,String.valueOf(farend_err));
            }
        }
        catch(Exception e){
            return false;
        }
        return true;
    }

    public void settext(int i,String s){
        String tmp = mtext[i].getText();
        String mode[] = {"RX","TX"};
        int idx;

        s = decompose(s);
        mtext[i].setText(s);
        if(tmp!=null&&!tmp.equals("")&&!tmp.equals(s))
           set_syslog(mode[i%2]+" "+mlabel[i/2].getText()+" changed:"+tmp+" -> "+s);
        if((idx=carrier_frame.getIndex(mlabel[i/2].getText()))>=0)
           carrier_frame.setItem(idx*2+i%2,s);
    }

    public synchronized void set_syslog(String s){
        String data = datetime()+" "+s+"\n";
        if(syslog.getText().length()>50*64) syslog.setText("");
        syslog.append(data);
        try{
            FileOutputStream fo = new FileOutputStream(syslog_file, true);
            fo.write(data.getBytes());
            fo.close();
        }
        catch(Exception e){}
    }

    public synchronized void set_status(String s){
        sts.setText(datetime()+" "+s);
    }

    public String datetime(){
        Calendar c = Calendar.getInstance();
        String year = String.valueOf(c.get(Calendar.YEAR));
        String month = String.valueOf(c.get(Calendar.MONTH)+1);
        String day = String.valueOf(c.get(Calendar.DAY_OF_MONTH));
        String hour = String.valueOf(c.get(Calendar.HOUR_OF_DAY));
        String min = String.valueOf(c.get(Calendar.MINUTE));
        String sec = String.valueOf(c.get(Calendar.SECOND));

        if(month.length()==1) month = "0"+month;
        if(day.length()==1) day = "0"+day;
        if(hour.length()==1) hour = "0"+hour;
        if(min.length()==1) min = "0"+min;
        if(sec.length()==1) sec = "0"+sec;
        return year+"/"+month+"/"+day+" "+hour+":"+min+":"+sec;
    }

    public String decompose(String s){
        int i;

        if((i=s.indexOf(":"))<0) return s.trim();
        else return s.substring(i+1).trim();
    }

    public int[] getarray(String s){
        StringTokenizer st, st2;
        String tmp;
        int i,j;
        int b[] = new int[256];

        st = new StringTokenizer(s,"\n");
        if(st.countTokens()!=64) {
            set_syslog("Broken data found, token!=64");
            return null;
        }
        i=0;
        while(st.hasMoreTokens()){
             tmp = st.nextToken();
             st2 = new StringTokenizer(tmp,"--");
             if(st2.countTokens()!=5){
                 set_syslog("Broken data found, token!=5:"+tmp);
                 return null;
             }
             st2.nextToken();
             while(st2.hasMoreTokens()){
                 tmp = st2.nextToken().trim();
                 if((j=tmp.indexOf("["))>0) tmp=tmp.substring(0,j);
                 tmp=tmp.trim();
                 try{
                    b[i] = Integer.parseInt(tmp); i++;
                 }
                 catch(Exception e){
                    set_syslog("Broken data found, not int:"+tmp);
                    return null;
                 }
             }
        }
        return b;
    }

    public boolean send_cmd(String s){
        String cmd = s+"\r";
        String line="";

        while(true){
            try{
                os.write(cmd.getBytes());os.flush();
                if(s.equals("restart")) return true;
                if((line=readLine(is))==null) return false;
                else if(!s.equals("") && line.startsWith(s)) return true;
                if(s.equals("")){
                    while(!line.endsWith("> ")&&!line.endsWith(pwd_prompt)){
                        if((line=readLine(is))==null) return false;
                    }
                    if(line.endsWith(pwd_prompt)) modem_status_chk(line);
                    else return true;
                }
                else{
                    while(!line.endsWith("> ")&&modem_status_chk(line)){
                        if((line=readLine(is))==null) return false;
                    }
                }
            }
            catch(Exception e) {
                break;
            }
        }
        return false;
    }

    public boolean modem_status_chk(String line){
        boolean wflg;

// Serial reboot
        if(line.endsWith(pwd_prompt)){
            send_pwd();
            save_current_status();
            return false;
        }
        if(line.indexOf("SHOWTIME_L0")>=0){
            send_cmd("");
            return false;
        }

// Normal Data
        if( (line.indexOf("NOT")<0||line.indexOf("SHOWTIME")<0) )
            return true;

// WLK Reset
        set_syslog("WLK Reset");
        save_current_status();
        if(si.isTcpip()&&ModemVer<NewVer) {
            while(true){
               if((line=readLine(is))==null) return false;
               else if(line.equals("")||line.endsWith("> ")) break;
            }
            wflg = false;
            while(!wflg){
               try{
                   Thread.currentThread().sleep(2000);
               }
               catch(Exception e){}
               if(!send_cmd("bsp mode")) return false;
               line = readLine(is);
               if((line=readLine(is))==null) return false;
               if(line.indexOf("SHOWTIME_L0")>=0) wflg=true;
               readLine(is);
            }
        }
        else {
            while(true){
                line = readLine(is);
                if(line==null) return false;
                if(line.indexOf("SHOWTIME_L0")>=0) break;
            }
        }
        set_syslog("WLK Established");
        return false;
    }

    public void save_current_status(){
        Calendar c = Calendar.getInstance();
        String year = String.valueOf(c.get(Calendar.YEAR));
        String month = String.valueOf(c.get(Calendar.MONTH)+1);
        String day = String.valueOf(c.get(Calendar.DAY_OF_MONTH));
        String hour = String.valueOf(c.get(Calendar.HOUR_OF_DAY));
        String min = String.valueOf(c.get(Calendar.MINUTE));
        String sec = String.valueOf(c.get(Calendar.SECOND));

        if(month.length()==1) month = "0"+month;
        if(day.length()==1) day = "0"+day;
        if(hour.length()==1) hour = "0"+hour;
        if(min.length()==1) min = "0"+min;
        if(sec.length()==1) sec = "0"+sec;
        String fname = year+month+day+"_"+hour+min+sec+".bit";
        save_file(fname);

        carrier_frame.copy_to_prev();
    }

    public boolean send_pwd(){
        String s = si.getPwd()+"\r";
        String line="";
        boolean loop=true;

        set_syslog("Modem Reboot. Try to Login");
        while(loop){
            try{
                os.write(s.getBytes());os.flush();
                while(true){
                    if((line=readLine(is))==null || line.endsWith(pwd_prompt)){
                        loop = false;
                        break;
                    }
                    if(line.endsWith("> ")) {
                        set_syslog("Success to Login");
                        return true;
                    }
                }
            }
            catch(Exception e) {loop=false;}
        }
        set_syslog("Fail to Login...Exit");
        disconnect_modem();
        return false;
    }

    public boolean init_modem(){
        String line=null;
        boolean flg = true;

set_syslog("Start to Init Modem Environment");
        if((flg=send_cmd("home")))
            while((line=readLine(is))!=null&&!line.endsWith("> "));
        if(flg&&send_cmd("event unshow"))
            while((line=readLine(is))!=null&&!line.endsWith("> "));
        if(line==null) flg = false;
        if(!flg) {
            set_syslog("Fail to Init Modem Environment");
            try{
               is.close();os.close();
            }
            catch(Exception e){}
        }
        else{
            set_syslog("Success to Init Modem Environment");
        }
        return flg;
    }

    public boolean get_version(){
        String line;
        String s="";

        if(!send_cmd("isfs cat info")) return false;

        while((line=readLine(is))!=null&&!line.endsWith("> "))
           s = s+line;
        if((ModemVer=getVersionNum(s))<0){
            set_syslog("Modem Version: UNDETECTED!!");
            NoticeDialog dia = new NoticeDialog(main_frame,"Fail to get Modem Version", "You may have problems with bsp down/up etc",true);
        }
        else{
            set_syslog("Modem Version: "+((double)ModemVer)/100);
        }
        return true;
    }

    int getVersionNum(String s){
        StringTokenizer st, st2;
        String tmp;
        String[] vs = {
   "J18L00301.00/1.1.e.05/1.2.6=110",
   "J18L00308.00/1.1.e.05/1.2.6=110",
   "3.0.3=300",
   "3.0.5=300",
   "3.0.6=320"
        };
        int i;

        if(s.charAt(0)==';') s = " "+s;

        st = new StringTokenizer(s,";");
        if(st.countTokens()<3) return -1;
        st.nextToken();st.nextToken();
        tmp = st.nextToken();
        tmp.trim();

        for(i=0; i<vs.length;i++){
            st2 = new StringTokenizer(vs[i],"=");
            if(st2.nextToken().equals(tmp)) return Integer.parseInt(st2.nextToken());
        }
        return 999;
    }

    public String readLine(InputStream is){
        byte[] buf = new byte[4096];
        byte b;
        int i,n;
        String s;

        try{
           for(i=0;i<buf.length;i++){
               if((n=is.read())==-1) return null;
               b = (byte)n;
               if(b=='\n') return new String(buf,0,i);
               if(b<' '&&b!='\t') b = ' ';
               buf[i]=b;
// Command Prompt
               if(i>0&&buf[i-1]=='>'&&buf[i]==' ') return new String(buf,0,i+1);
// PASSWORD: Prompt
               if(i>=8&&buf[i]==':') {
                    s = new String(buf,0,i+1);
                    if(s.toUpperCase().endsWith(pwd_prompt)) return s;
               }
           }
           return "";
        }
        catch(InterruptedIOException e){
             return "";
        }
        catch(Exception e){
           return null;
        }
    }

    public String copy(){
        String s = "";
        s = "/****   "+datetime()+"   ****/"+"\n";
        s = s+"> bsp channel\n";
        s = s+"Actual Bit Rate (NEAR END FAST CHANNEL): "+mtext[0].getText()+"\n";
        s = s+"Actual Bit Rate (FAR END FAST CHANNEL): "+mtext[1].getText()+"\n";
        s = s+"Actual Bit Rate (NEAR END INTERLEAVED CHANNEL): "+mtext[2].getText()+"\n";
        s = s+"Actual Bit Rate (FAR END INTERLEAVED CHANNEL): "+mtext[3].getText()+"\n";
        s = s+"\n";
        s = s+"> bsp line\n";
        s = s+"Downstream Capacity Occupation : "+mtext[4].getText()+"\n";
        s = s+"Downstream Noise Margin  : "+mtext[6].getText()+"\n";
        s = s+"Downstream Attenuation   : "+mtext[8].getText()+"\n";
        s = s+"Downstream Output Power  : "+mtext[10].getText()+"\n";
        s = s+"Upstream Capacity Occupation : "+mtext[5].getText()+"\n";
        s = s+"Upstream Noise Margin  : "+mtext[7].getText()+"\n";
        s = s+"Upstream Attenuation   : "+mtext[9].getText()+"\n";
        s = s+"Upstream Output Power  : "+mtext[11].getText()+"\n";
        s = s+"Carrier Load (bits/tone)\n"+carrier_frame.gettext()+"\n";
        return s;
    }

    public void save(){
        FileDialog fd = new FileDialog(main_frame);
        fd.setDirectory(".");
        fd.setFile("*.bit");
        fd.setMode(FileDialog.SAVE);
        fd.show();
        String fname = fd.getFile();
        if(fname==null) return;
        fname = fd.getDirectory()+fname;
        save_file(fname);
    }

    public void save_file(String fname){
        try{
            FileOutputStream fo = new FileOutputStream(fname, false);
            fo.write(copy().getBytes());
            fo.close();
        }
        catch(Exception e){
            NoticeDialog dia = new NoticeDialog(main_frame,"Fail to save file",e.toString(),true);
        }
    }

// External use
    public int read(byte[] buf){
        try{
             return is.read(buf);
        }
        catch(InterruptedIOException e){
             return 0;
        }
        catch(Exception e){
             return -1;
        }
    }

    public boolean write(byte[] b){
        try{
            os.write(b);
            return true;
        }
        catch(Exception e){
            return false;
        }
    }

    public void restart(){
        if(th==null) start_child();
        else resume_child();
    }
}

class CarrierFrame extends Frame implements WindowListener,ActionListener{
    TextArea current, prev;
    Button draw, close, current_clr, prev_clr, prev_read, current_read;
    DrawPanel graph;
    Checkbox current_box, prev_box;

    TextField current_line[], prev_line[];
    Label clabel[], plabel[];

    Color current_color[] = {Color.blue, Color.cyan};
    Color prev_color[] = {Color.red, Color.orange};

    public CarrierFrame(Frame f, String title){
        super(title);

        Panel north_panel;
        Panel center_panel;
        Panel south_panel;
        Panel tmp, tmp2, tmp3,tmp4,tmp5, tmp6,tmp7;
        TextField pos;
        int i,j;

        addWindowListener(this);

        setLayout(new BorderLayout());
        setBackground(Color.pink);
        setForeground(Color.black);

        north_panel = new Panel();
        north_panel.setLayout(new FlowLayout(FlowLayout.LEFT,2,2));
        north_panel.add(draw=new Button("DRAW"));
        north_panel.add(new Label(" "));
        north_panel.add(close=new Button("CLOSE"));
        north_panel.add(new Label(" "));
        north_panel.add(new Label("Position"));
        north_panel.add(pos=new TextField(15));
        pos.setEditable(false);
        pos.setBackground(getBackground());
        pos.setForeground(getForeground());

        center_panel = new Panel();
        center_panel.setLayout(new GridLayout(2,1));
        graph = new DrawPanel(pos);
        graph.setBackground(Color.white);
        tmp = new Panel();
        center_panel.add(graph,0);
        center_panel.add(tmp,1);
        tmp.setLayout(new GridLayout(1,2));
        tmp2 = new Panel(); tmp3 = new Panel();
        tmp.add(tmp2,0); tmp.add(tmp3,1);
        tmp2.setLayout(new BorderLayout());tmp3.setLayout(new BorderLayout());
        tmp4 = new Panel(); tmp5 = new Panel();
        tmp4.setLayout(new GridLayout(8,3));tmp5.setLayout(new GridLayout(8,3));
        current_line = new TextField[14]; prev_line = new TextField[14];
        for(i=0;i<14;i++){
            current_line[i] = new TextField(); current_line[i].setEditable(false);
            current_line[i].setBackground(getBackground());
            current_line[i].setForeground(getForeground());
            prev_line[i] = new TextField(); prev_line[i].setEditable(false);
            prev_line[i].setBackground(getBackground());
            prev_line[i].setForeground(getForeground());
        }
        clabel = new Label[7]; plabel = new Label[7];
        for(i=0;i<7;i++) {clabel[i] = new Label(); plabel[i]= new Label();}
        clabel[0].setText("Fast Channel"); plabel[0].setText("Fast Channel");
        clabel[1].setText("Interleaved Channel"); plabel[1].setText("Interleaved Channel");
        clabel[2].setText("Capacity Occupation");plabel[2].setText("Capacity Occupation");
        clabel[3].setText("Noise Margin");plabel[3].setText("Noise Margin");
        clabel[4].setText("Attenuation");plabel[4].setText("Attenuation");
        clabel[5].setText("Output Power");plabel[5].setText("Output Power");
        clabel[6].setText("Carrier Load");plabel[6].setText("Carrier Load");
        tmp4.add(new Label("Current"),0);tmp4.add(new Label("Downstream"),1);tmp4.add(new Label("Upstream"),2);
        tmp5.add(new Label("Previous"),0);tmp5.add(new Label("Downstream"),1);tmp5.add(new Label("Upstream"),2);
        j=3;
        for(i=0;i<7;i++){
           tmp4.add(clabel[i],j); tmp5.add(plabel[i],j);j++;
           tmp4.add(current_line[2*i],j); tmp5.add(prev_line[2*i],j);j++;
           tmp4.add(current_line[2*i+1],j); tmp5.add(prev_line[2*i+1],j);j++;
        }
        tmp2.add("Center",tmp4); tmp3.add("Center",tmp5);
        tmp2.add("South",current=new TextArea(4,45)); current.setEditable(false);
        tmp3.add("South",prev=new TextArea(4,45)); prev.setEditable(false);
        current.setForeground(current_color[0]);
        prev.setForeground(prev_color[0]);

        south_panel = new Panel();
        south_panel.setLayout(new GridLayout(1,2));
        tmp6 = new Panel(); tmp7 = new Panel();
        south_panel.add(tmp6,0); south_panel.add(tmp7,1);
        tmp6.setLayout(new FlowLayout(FlowLayout.LEFT,2,2));
        tmp7.setLayout(new FlowLayout(FlowLayout.LEFT,2,2));
        tmp6.add(current_box = new Checkbox("Current",true));
        tmp6.add(current_clr = new Button("CLR"));
        tmp6.add(new Label(" "));
        tmp6.add(current_read = new Button("READ"));
        tmp6.add(new Label(" "));
        tmp7.add(prev_box = new Checkbox("Previous",true));
        tmp7.add(prev_clr = new Button("CLR"));
        tmp7.add(new Label(" "));
        tmp7.add(prev_read = new Button("READ"));

        add("North",north_panel);
        add("Center",center_panel);
        add("South",south_panel);
/*
    Button draw, close, current_clr, prev_clr, prev_read, current_read, save;
*/
        draw.setActionCommand("draw"); draw.addActionListener(this);
        close.setActionCommand("close"); close.addActionListener(this);
        current_clr.setActionCommand("current_clr"); current_clr.addActionListener(this);
        prev_clr.setActionCommand("prev_clr"); prev_clr.addActionListener(this);
        prev_read.setActionCommand("prev_read"); prev_read.addActionListener(this);
        current_read.setActionCommand("current_read"); current_read.addActionListener(this);

        pack();

    }

    public void settext(String s){
        current.setText(s);
        draw_ctrl();
    }

    public String gettext(){
        return current.getText();
    }

    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        int i;

        if(cmd.equals(draw.getActionCommand()))
            draw_ctrl();
        else if(cmd.equals(close.getActionCommand()))
            setVisible(false);
        else if(cmd.equals(current_clr.getActionCommand())){
            for(i=0;i<current_line.length;i++) current_line[i].setText("");
            current.setText("");
        }
        else if(cmd.equals(prev_clr.getActionCommand())){
            for(i=0;i<prev_line.length;i++) prev_line[i].setText("");
            prev.setText("");
        }
        else if(cmd.equals(prev_read.getActionCommand()))
            read_file(prev, prev_line);
        else if(cmd.equals(current_read.getActionCommand()))
            read_file(current, current_line);
    }

    public void windowOpened(WindowEvent e){
    }
    public void windowClosing(WindowEvent e){
        setVisible(false);
    }
    public void windowClosed(WindowEvent e){
    }
    public void windowIconified(WindowEvent e){
    }
    public void windowDeiconified(WindowEvent e){
    }
    public void windowActivated(WindowEvent e){
        draw_ctrl();
    }
    public void windowDeactivated(WindowEvent e){
    }

    public void read_file(TextArea area, TextField txt[]){
        int n[], i;
        FileDialog fd = new FileDialog(this);
        fd.setDirectory(".");
        fd.setFile("*.bit");
        fd.setMode(FileDialog.LOAD);
        fd.show();
        String fname = fd.getFile();
        if(fname==null) return;
        fname = fd.getDirectory()+fname;
        String line="", last="";
        boolean ecflg, bitend;

        try{
            BufferedReader in = new BufferedReader(new FileReader(fname));
            area.setText(""); ecflg=false; bitend=false;
            for(i=0;i<txt.length;i++) txt[i].setText("");
            while((line=in.readLine())!=null) {
                if(last.indexOf("[")>=0&&line.indexOf("[")<0) bitend=true;
                if(bitend&&line.indexOf("[")>=0) {
                    if(!ecflg) area.append("////\n");
                    ecflg=true;
                }
                setScr(line, area, txt);
                last=line;
            }
            in.close();
            if(!ecflg&&(n=getarray(area.getText()))!=null){
                int ubit=0,dbit=0;
                for(i=0;i<32;i++) ubit += n[i];
                for(i=32;i<256;i++) dbit += n[i];
                txt[12].setText(String.valueOf(dbit));
                txt[13].setText(String.valueOf(ubit));
            }
            else if(ecflg){
                int bit,j=0;
                StringTokenizer st = new StringTokenizer(area.getText(),"////");
                while(st.hasMoreTokens()){
                    bit=0;
                    n = getarray(st.nextToken());
                    for(i=0;i<n.length;i++) bit += n[i];
                    txt[12+j].setText(String.valueOf(bit));j++;
                }
            }
        }
        catch(Exception e){}
    }

    public void setScr(String s, TextArea area, TextField txt[]){
        String s1, s2, line;
        int i;

        line=s;
        if((i=s.indexOf(":"))>0){
            s2=s.substring(i+1);
            s1=s.substring(0,i+1);
            line=(s1.toUpperCase()+s2);
        }
        if((line.indexOf("NEAR END")>0||line.indexOf("DOWNSTREAM")>0)&&line.indexOf("FAST CHANNEL")>0)
             txt[0].setText(decompose(line));
        else if((line.indexOf("FAR END")>0||line.indexOf("UPSTREAM")>0)&&line.indexOf("FAST CHANNEL")>0)
             txt[1].setText(decompose(line));
        if((line.indexOf("NEAR END")>0||line.indexOf("DOWNSTREAM")>0)&&line.indexOf("INTERLEAVED CHANNEL")>0)
             txt[2].setText(decompose(line));
        else if((line.indexOf("FAR END")>0||line.indexOf("UPSTREAM")>0)&&line.indexOf("INTERLEAVED CHANNEL")>0)
             txt[3].setText(decompose(line));
        else if(line.indexOf("DOWNSTREAM")>=0&&line.indexOf("CAPACITY")>0)
             txt[4].setText(decompose(line));
        else if(line.indexOf("UPSTREAM")>=0&&line.indexOf("CAPACITY")>0)
             txt[5].setText(decompose(line));
        else if(line.indexOf("DOWNSTREAM")>=0&&line.indexOf("NOISE")>0)
             txt[6].setText(decompose(line));
        else if(line.indexOf("UPSTREAM")>=0&&line.indexOf("NOISE")>0)
             txt[7].setText(decompose(line));
        else if(line.indexOf("DOWNSTREAM")>=0&&line.indexOf("ATTENUATION")>0)
             txt[8].setText(decompose(line));
        else if(line.indexOf("UPSTREAM")>=0&&line.indexOf("ATTENUATION")>0)
             txt[9].setText(decompose(line));
        else if(line.indexOf("DOWNSTREAM")>=0&&line.indexOf("OUTPUT")>=0)
             txt[10].setText(decompose(line));
        else if(line.indexOf("UPSTREAM")>=0&&line.indexOf("OUTPUT")>=0)
             txt[11].setText(decompose(line));
        else if(line.indexOf("[")>=0)
             area.append(line+"\n");
    }

    public String decompose(String s){
        int i;

        if((i=s.indexOf(":"))<0) return s.trim();
        else return s.substring(i+1).trim();
    }

    public void draw_ctrl(){
        int current_bits[][], prev_bits[][], tmp[], ccnt, pcnt;
        int ymax=0, i, j;
        StringTokenizer st;

        graph.update(graph.getGraphics());

        current_bits = new int[2][256];
        prev_bits = new int[2][256];

        st = new StringTokenizer(prev.getText(),"////");
        pcnt = st.countTokens();
        for(j=0; j<pcnt; j++){
            tmp = getarray(st.nextToken());
            for(i=0;i<tmp.length;i++) prev_bits[j][i]=tmp[i];
        }
        st = new StringTokenizer(current.getText(),"////");
        ccnt = st.countTokens();
        for(j=0; j<ccnt; j++){
            tmp = getarray(st.nextToken());
            for(i=0;i<tmp.length;i++) current_bits[j][i]=tmp[i];
        }
        if(prev_box.getState()){
            for(j=0;j<pcnt;j++) for(i=0;i<prev_bits[j].length;i++) if(prev_bits[j][i]>ymax) ymax=prev_bits[j][i];
        }
        if(current_box.getState()){
            for(j=0;j<ccnt;j++) for(i=0;i<current_bits[j].length;i++) if(current_bits[j][i]>ymax) ymax=current_bits[j][i];
        }
        if(ymax==0) return;

        graph.ymax = ymax;

        if(prev_box.getState()){
            for(j=0;j<pcnt;j++) graph.draw(prev_bits[j],prev_color[j]);
        }
        if(current_box.getState()){
            for(j=0;j<ccnt;j++) graph.draw(current_bits[j], current_color[j]);
        }
    }

    public int[] getarray(String s){
        StringTokenizer st, st2;
        String tmp;
        int i,j;
        int b[] = new int[256];

        if(s.equals("")) return b;
        st = new StringTokenizer(s,"\n");
        if(st.countTokens()!=64&&st.countTokens()!=8) {
            return null;
        }
        i=0;
        while(st.hasMoreTokens()){
             tmp = st.nextToken();
             st2 = new StringTokenizer(tmp,"--");
             if(st2.countTokens()!=5){
                 return null;
             }
             st2.nextToken();
             while(st2.hasMoreTokens()){
                 tmp = st2.nextToken().trim();
                 if((j=tmp.indexOf("["))>0) tmp=tmp.substring(0,j);
                 tmp=tmp.trim();
                 try{
                    b[i] = Integer.parseInt(tmp); i++;
                 }
                 catch(Exception e){
                    return null;
                 }
             }
        }
        return b;
    }

// External use

    public int getIndex(String s){
        int i;
        for(i=0;i<clabel.length;i++){
            if(s.equals(clabel[i].getText())) return i;
        }
        return -1;
    }

    public boolean setItem(int i, String s){
        if(i>=current_line.length || i<0) return false;
        current_line[i].setText(s);
        return true;
    }

    public void copy_to_prev(){
        int i;
        for(i=0;i<current_line.length;i++)
            prev_line[i].setText(current_line[i].getText());
        prev.setText(current.getText());
    }
}

class DrawPanel extends Panel implements MouseListener, MouseMotionListener {
    TextField pos;
    int xmax=0, ymax=0;
    int Xmax=0, Ymax=0;

    public DrawPanel(TextField pos) {
         this.pos = pos;
	 addMouseMotionListener(this);
	 addMouseListener(this);
         pos.setText("Put Cursor on Graph");
    }

    public void mouseDragged(MouseEvent e) {
    }

    public void mouseMoved(MouseEvent e) {
         print_position(e);
    }

    public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
         print_position(e);
    }

    public void mouseExited(MouseEvent e) {
         pos.setText("Put Cursor on Graph");
    }

    public void mouseClicked(MouseEvent e) {
    }

    public void print_position(MouseEvent e){
         int x,y,hz;

         if(Xmax==0||Ymax==0) return;
         x = e.getX()*xmax/Xmax;
         hz = (int)(4.3125*x);
         y = (getSize().height-e.getY())*ymax/Ymax;
         String tmp="";
         tmp += "[";
         tmp += String.valueOf(x);
         tmp += "]";
         tmp += "=";
         tmp += String.valueOf(hz);
         tmp += "khz";
         tmp += ",";
         tmp += String.valueOf(y);
         pos.setText(tmp);
    }

    public void draw(int y[], Color c){
        Point current[]=null;
        int i;
        Graphics g = getGraphics();

        if(y==null||y.length==0) return;

        xmax = y.length;

        current = new Point[y.length];
        for(i=0;i<y.length;i++) {
           current[i] = new Point(0,0);
        }
        Xmax = (int)(getSize().width*0.9);
        Ymax = (int)(getSize().height*0.9);
        for(i=0;i<y.length;i++){
            current[i].x = (int)(Xmax*i/xmax);
            current[i].y = (int)(Ymax*y[i]/ymax);
        }

        g.setColor(Color.black);
        for(i=0;i<2;i++){
            g.drawLine(0,getSize().height-i, getSize().width,getSize().height-i);
            g.drawLine(i,0,i,this.getSize().height);
        }
        g.drawString("Tone",Xmax+4, getSize().height-4);
        g.drawString("Bits",4,getSize().height-Ymax-10);

        g.setColor(c);
        for(i=0;i<(y.length-1);i++){
            g.drawLine(current[i].x,getSize().height-current[i].y, current[i+1].x, getSize().height-current[i+1].y);
        }
    }
}

class ErrorFrame extends Frame implements WindowListener,ActionListener{
    MenuItem Close;
    TextField dl_fec, dl_crc, dl_hec, dl_inter_fec, dl_inter_crc, dl_inter_hec,
              up_fec, up_crc, up_hec, up_inter_fec, up_inter_crc, up_inter_hec;

    public ErrorFrame(Frame f, String title){
        super(title);

        Panel center;

        addWindowListener(this);

        MenuBar mb = new MenuBar();
        setMenuBar(mb);
        Menu mfile = new Menu("File");
        mb.add(mfile);
        Close = new MenuItem("Close");
        mfile.add(Close);
        Close.addActionListener(this);

        setLayout(new BorderLayout());
        setBackground(Color.pink);
        setForeground(Color.black);

        center = new Panel();
        center.setLayout(new GridLayout(7,3));
        center.add(new Label(" "),0);center.add(new Label("Downstream"),1);center.add(new Label("Upstream"),2);
        center.add(new Label("Fast Channel FEC"),3);center.add(dl_fec=new TextField(),4);center.add(up_fec=new TextField(),5);
        center.add(new Label("Fast Channel CRC"),6);center.add(dl_crc=new TextField(),7);center.add(up_crc=new TextField(),8);
        center.add(new Label("Fast Channel HEC"),9);center.add(dl_hec=new TextField(),10);center.add(up_hec=new TextField(),11);
    center.add(new Label("Interleaved  FEC"),12);center.add(dl_inter_fec=new TextField(),13);center.add(up_inter_fec=new TextField(),14);
    center.add(new Label("Interleaved  CRC"),15);center.add(dl_inter_crc=new TextField(),16);center.add(up_inter_crc=new TextField(),17);
    center.add(new Label("Interleaved  HEC"),18);center.add(dl_inter_hec=new TextField(),19);center.add(up_inter_hec=new TextField(),20);

    dl_fec.setEditable(false); dl_crc.setEditable(false); dl_hec.setEditable(false);
    dl_inter_fec.setEditable(false); dl_inter_crc.setEditable(false); dl_inter_hec.setEditable(false);
    up_fec.setEditable(false); up_crc.setEditable(false); up_hec.setEditable(false);
    up_inter_fec.setEditable(false); up_inter_crc.setEditable(false); up_inter_hec.setEditable(false);

    dl_fec.setBackground(getBackground());dl_fec.setForeground(getForeground());
    dl_crc.setBackground(getBackground());dl_crc.setForeground(getForeground());
    dl_hec.setBackground(getBackground());dl_hec.setForeground(getForeground());
    dl_inter_fec.setBackground(getBackground());dl_inter_fec.setForeground(getForeground());
    dl_inter_crc.setBackground(getBackground());dl_inter_crc.setForeground(getForeground());
    dl_inter_hec.setBackground(getBackground());dl_inter_hec.setForeground(getForeground());

    up_fec.setBackground(getBackground());up_fec.setForeground(getForeground());
    up_crc.setBackground(getBackground());up_crc.setForeground(getForeground());
    up_hec.setBackground(getBackground());up_hec.setForeground(getForeground());
    up_inter_fec.setBackground(getBackground());up_inter_fec.setForeground(getForeground());
    up_inter_crc.setBackground(getBackground());up_inter_crc.setForeground(getForeground());
    up_inter_hec.setBackground(getBackground());up_inter_hec.setForeground(getForeground());

        add("Center",center);
        pack();
    }

    public void actionPerformed(ActionEvent e) {
        if(e.getActionCommand().equals(Close.getActionCommand()))
            setVisible(false);
    }

    public void windowOpened(WindowEvent e){
    }
    public void windowClosing(WindowEvent e){
        setVisible(false);
    }
    public void windowClosed(WindowEvent e){
    }
    public void windowIconified(WindowEvent e){
    }
    public void windowDeiconified(WindowEvent e){
    }
    public void windowActivated(WindowEvent e){
    }
    public void windowDeactivated(WindowEvent e){
    }
}

class CmdFrame extends Frame implements WindowListener,ActionListener,KeyListener,MouseListener,ClipboardOwner,Runnable{
    TextField cmd;
    TextArea result;
    Button send;

    MenuItem Close;
    MenuItem Clear;

    KeyEvent ke;

    Thread th;

    modem parent;

    Clipboard clipboard = getToolkit().getSystemClipboard();

    public CmdFrame(modem parent, String title){
        super(title);

        this.parent = parent;

        addWindowListener(this);

        setLayout(new BorderLayout());
        setBackground(parent.getBackground());
        setForeground(parent.getForeground());

        Panel p = new Panel();
        p.setLayout(new FlowLayout(FlowLayout.LEFT,2,2));
        p.add(cmd = new TextField(48));
        cmd.setBackground(Color.white);
        cmd.setForeground(Color.black);
        p.add(send = new Button("SEND"));
        send.addActionListener(this);
        add("North",p);
        add("Center", result=new TextArea(16,70)); result.setEditable(false);
        result.setBackground(getBackground());
        result.setForeground(getForeground());
        cmd.addKeyListener(this);
        cmd.addMouseListener(this);
        result.addMouseListener(this);

        MenuBar mb=new MenuBar();
        setMenuBar(mb);
        Menu mfile = new Menu("File");
        Menu medit = new Menu("Edit");
        mb.add(mfile);mb.add(medit);
        Close = new MenuItem("Close");
        Clear = new MenuItem("Clear");
        mfile.add(Close);
        medit.add(Clear);
        Close.addActionListener(this);
        Clear.addActionListener(this);

        pack();
    }

    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();

        if(cmd.equals(Close.getActionCommand()))
             close_window();
        else if(cmd.equals(Clear.getActionCommand()))
             result.setText("");
        else if(cmd.equals(send.getActionCommand())){
             send_cmd();
        }
    }

    public void run(){
        int n;
        byte[] buf = new byte[4096];

        while((n=parent.read(buf))>=0)
            if(n>0) result.append(new String(buf,0,n));

        NoticeDialog dia = new NoticeDialog(
           this,"Fail to read","Confirm if the connection is established and open this window again",true);
        th = null;
    }

    public void windowOpened(WindowEvent e){
        th = new Thread(this);th.start();
    }

    public void windowClosing(WindowEvent e){
        close_window();
    }

    public void windowClosed(WindowEvent e){
    }
    public void windowIconified(WindowEvent e){
    }
    public void windowDeiconified(WindowEvent e){
    }
    public void windowActivated(WindowEvent e){
    }
    public void windowDeactivated(WindowEvent e){
    }

    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        if(e.getKeyCode()==KeyEvent.VK_ENTER) send_cmd();
    }
    public void keyReleased(KeyEvent e){
    }

    public void mousePressed(MouseEvent e) {
    }
    public void mouseReleased(MouseEvent e) {
        if(e.getComponent()==result&&e.getModifiers()==InputEvent.BUTTON1_MASK){ // Left Button
            String srcData = result.getSelectedText();
            if(!srcData.equals("")){
                StringSelection contents = new StringSelection(srcData);
                clipboard.setContents(contents, this);
            }
        }
    }
    public void mouseEntered(MouseEvent e) {
    }
    public void mouseExited(MouseEvent e) {
    }
    public void mouseClicked(MouseEvent e) {
        if(e.getComponent()==cmd&&e.getModifiers()==InputEvent.BUTTON3_MASK){ // Right Button
            Transferable content = clipboard.getContents(this);
            if(content!=null) {
                try {
                    String dstData = (String)content.getTransferData(DataFlavor.stringFlavor);
                    cmd.setText(cmd.getText()+dstData);
                } 
                catch (Exception ee) {}
             }
        }
    }

    public void lostOwnership(Clipboard clipboard, Transferable contents) {
    }

    public void close_window(){
parent.set_syslog("Close Command Input Window");
        if(th!=null){
           th.stop();
           parent.init_modem();
           parent.restart();
        }
        setVisible(false);
        dispose();
    }

    public void send_cmd(){
        String s = cmd.getText()+"\r";
        if(!parent.write(s.getBytes())){
            NoticeDialog dia = new NoticeDialog(
           this,"Fail to send command","Confirm if the connection is established and open this window again",true);
            th.stop();th=null;
        }
        cmd.setText("");
    }
}

class ConfirmDialog extends Dialog implements ActionListener{
    boolean flg=true;
    Button ok, cancel;

    public ConfirmDialog(Frame f,String msg){
        super(f,"Confirmation",true);

        Panel north,south;
        Point pt;
        Dimension dim;

        north = new Panel();
        north.setLayout(new GridLayout(3, 1));
        north.add(new Label(""),0);
        north.add(new Label(msg,Label.CENTER),1);
        north.add(new Label(""),2);
        south = new Panel();
        south.setLayout(new GridLayout(1,2));
        south.add(ok=new Button("Yes"),0);
        south.add(cancel=new Button("No!"),1);

        add("North",north);
        add("South",south);

        ok.setActionCommand(ok.getLabel());
        cancel.setActionCommand(cancel.getLabel());
	ok.addActionListener(this);
	cancel.addActionListener(this);

        setSize(40+getFontMetrics(getFont()).stringWidth(msg), 150);
        pt = f.getLocationOnScreen();
        dim = f.getSize();
        pt.x += dim.width/2;
        pt.y += dim.height/2;
        setLocation(pt);
//        pack();
        show();
    }

    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        if(cmd.equals(ok.getActionCommand())){
            dispose();
            flg=true;
        }
        if(cmd.equals(cancel.getActionCommand())){
            dispose();
            flg=false;
        }
    }

    public boolean get_status(){
        return flg;
    }
}

class NoticeDialog extends Dialog implements ActionListener{
    Button ok;

    public NoticeDialog(Frame f,String msg1,String msg2,boolean modal){
        super(f,"Notice",modal);

        Panel north,south, tmp,tmp2;
        Point pt;
        Dimension dim;
        int len;
        FontMetrics fm;

        north = new Panel();
        north.setLayout(new GridLayout(3, 1));
        north.add(new Label(""),0);
        north.add(new Label(msg1,Label.CENTER),1);
        north.add(new Label(msg2,Label.CENTER),2);
        south = new Panel();
        south.add(ok=new Button("OK"));
        add("North",north);
        add("South",south);

        ok.setActionCommand(ok.getLabel());
	ok.addActionListener(this);

        fm = getFontMetrics(getFont());
        if(fm.stringWidth(msg1)>fm.stringWidth(msg2))
            len = fm.stringWidth(msg1);
        else
            len = fm.stringWidth(msg2);
        setSize(40+len, 150);

        pt = f.getLocationOnScreen();
        dim = f.getSize();
        pt.x += dim.width/2;
        pt.y += dim.height/2;
        setLocation(pt);
//        pack();
        show();
    }

    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        if(cmd.equals(ok.getActionCommand()))
            dispose();
    }
}

class SettingDialog extends Dialog implements ActionListener{
    TextField pwd, ipaddr, macaddr, arpcmd;
    Checkbox serial, tcpip;
    Choice portlist;

    Button ok, cancel;

    SettingInfo si;

    Frame parent;

    public SettingDialog(Frame f,String title){
        super(f,title,true);

        parent = f;

        Panel north,center,south, tmp1,tmp2,tmp3,tmp4,tmp5;
        CheckboxGroup cbg = new CheckboxGroup();
        Point pt;
        Dimension dim;

        CommPortIdentifier id;
        Enumeration list;

        si = new SettingInfo();

        north = new Panel();
        north.setLayout(new GridLayout(2, 2));
        north.add(new Label("Password: "),0);
        north.add(pwd=new TextField(si.getPwd()),1);
        pwd.setEchoChar('*');
        north.add(new Label(""),2);north.add(new Label(""),3);

        center = new Panel();
        center.setLayout(new BorderLayout());
        tmp1 = new Panel(); tmp2 = new Panel();
        center.add("North",tmp1); center.add("South",tmp2);

        tmp1.setLayout(new GridLayout(2, 2));
        tmp1.add(tmp3=new Panel(),0);
        tmp3.setLayout(new GridLayout(1, 2));
        tmp3.add(serial=new Checkbox("Serial",cbg,si.isSerial()),0);
        tmp3.add(new Label("Port:"),1);
        tmp1.add(portlist=new Choice(),1);
        tmp1.add(new Label(""),2);tmp1.add(new Label(""),3);
        list = CommPortIdentifier.getPortIdentifiers();
        while (list.hasMoreElements()) {
            id = (CommPortIdentifier) list.nextElement();
            if (id.getPortType() == CommPortIdentifier.PORT_SERIAL)
                portlist.add(id.getName());
        }
        portlist.select(si.getPort());

        tmp2.setLayout(new GridLayout(1, 2));
        tmp2.add(tmp4=new Panel(),0);
        tmp4.setLayout(new GridLayout(3, 2));
        tmp4.add(tcpip=new Checkbox("TCP/IP",cbg,si.isTcpip()),0);
        tmp4.add(new Label("IP Address:"),1);
        tmp4.add(new Label(""),2);
        tmp4.add(new Label("MAC Address:"),3);
        tmp4.add(new Label(""),4);
        tmp4.add(new Label("ARP Command:"),5);

        tmp2.add(tmp5=new Panel(),1);
        tmp5.setLayout(new GridLayout(3, 1));
        tmp5.add(ipaddr = new TextField(si.getIpaddr()),0);
        tmp5.add(macaddr = new TextField(si.getMacaddr()),1);
        tmp5.add(arpcmd = new TextField(si.getArpcmd()),2);

        south = new Panel();
        south.setLayout(new GridLayout(1,2));
        south.add(ok=new Button("SAVE"),0);
        south.add(cancel=new Button("CANCEL"),1);

        add("North",north);
        add("Center",center);
        add("South",south);

        ok.setActionCommand(ok.getLabel());
        cancel.setActionCommand(cancel.getLabel());
	ok.addActionListener(this);
	cancel.addActionListener(this);

        pt = f.getLocationOnScreen();
        dim = f.getSize();
        pt.x += dim.width/2;
        pt.y += dim.height/2;
        setLocation(pt);
        pack();
        show();
    }

    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        if(cmd.equals(ok.getActionCommand())){
           if(pwd.getText().equals("")){
                NoticeDialog dia = new NoticeDialog(
                    parent,"Input Error",
                   "Password is always needed when login the modem",
                    true);
                return;
           }
           if(tcpip.getState()&&ipaddr.getText().equals("")){
                NoticeDialog dia = new NoticeDialog(
                    parent,"Input Error",
                   "You must input IP Address if you want to connect by tcpip",
                    true);
                return;
           }
           si.setPwd(pwd.getText());
           si.setSerial(serial.getState());
           si.setTcpip(tcpip.getState());
           si.setPort(portlist.getSelectedItem());
           si.setIpaddr(ipaddr.getText());
           si.setMacaddr(macaddr.getText());
           si.setArpcmd(arpcmd.getText());
           if(!si.write()){
                NoticeDialog dia = new NoticeDialog(
                    parent,"Fail to save",
                           "Check permission of the file and directory, then try again",
                    true);
                return;
           }
        }
        dispose();
    }
}

class SettingInfo {
    String fname = "modem.conf";
    String pwd="";
    boolean serial=false, tcpip=true;
    String port="";
    String ipaddr="", macaddr="", arpcmd="";

    public SettingInfo(){
        try{
            BufferedReader br = new BufferedReader(new FileReader(fname));
            String line, name, data;
            int i;
            while((line=br.readLine())!=null){
                if((i=line.indexOf('\t'))>0){
                    name = line.substring(0,i);
                    data = line.substring(i+1);
                    if(name.equals("pwd"))
                        pwd = data;
                    else if(name.equals("method")&&data.equals("serial")){
                        serial = true; tcpip = false;
                    }
                    else if(name.equals("method")&&data.equals("tcpip")){
                        serial = false; tcpip = true;
                    }
                    else if(name.equals("port"))
                        port = data;
                    else if(name.equals("ipaddr"))
                        ipaddr = data;
                    else if(name.equals("macaddr"))
                        macaddr = data;
                    else if(name.equals("arpcmd"))
                        arpcmd = data;
                }
            }
        }
        catch(Exception e){
            ipaddr="172.16.255.254";
            pwd = "field_service";
        }
    }

    public String getPwd(){
        return pwd;
    }
    public boolean isSerial(){
        return serial;
    }
    public String getPort(){
        return port;
    }
    public boolean isTcpip(){
        return tcpip;
    }
    public String getIpaddr(){
        return ipaddr;
    }
    public String getMacaddr(){
        return macaddr;
    }
    public String getArpcmd(){
        return arpcmd;
    }

    public void setPwd(String s){
        pwd = s;
    }
    public void setSerial(boolean flg){
        serial=flg;
        if(flg) tcpip = false;
        else tcpip = true;
    }
    public void setPort(String s){
        port = s;
    }
    public void setTcpip(boolean flg){
        tcpip=flg;
        if(flg) serial = false;
        else serial = true;
    }
    public void setIpaddr(String s){
        ipaddr = s;
    }
    public void setMacaddr(String s){
        macaddr = s;
    }
    public void setArpcmd(String s){
        arpcmd = s;
    }

    public boolean write(){
       try{
          PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(fname,false)));
          out.println("pwd\t"+pwd);
          if(serial) out.println("method\t"+"serial");
          else       out.println("method\t"+"tcpip");
          out.println("port\t"+port);
          out.println("ipaddr\t"+ipaddr);
          out.println("macaddr\t"+macaddr);
          out.println("arpcmd\t"+arpcmd);
          out.flush(); out.close();
          return true;
       }
       catch(Exception e){
           return false;
       }
    }
}

class PreferDialog extends Dialog implements ActionListener{
    TextField loop_int, downup_int;

    Button ok, cancel;

    PreferInfo pi;

    Frame parent;

    public PreferDialog(Frame f,String title){
        super(f,title,true);

        parent = f;

        Panel north,south, tmp1,tmp2;
        Point pt;
        Dimension dim;

        pi = new PreferInfo();

        north = new Panel();
        north.setLayout(new GridLayout(3, 2));
        north.add(new Label("Loop Interval:"),0);
        tmp1 = new Panel();
        tmp1.setLayout(new FlowLayout(FlowLayout.LEFT,2,2));
        north.add(tmp1,1);
        tmp1.add(loop_int=new TextField(String.valueOf(pi.getLoopInt())));
        tmp1.add(new Label("sec"));
        north.add(new Label("bsp down/up Interval:"),2);
        tmp2 = new Panel();
        tmp2.setLayout(new FlowLayout(FlowLayout.LEFT,2,2));
        north.add(tmp2,3);
        tmp2.add(downup_int=new TextField(String.valueOf(pi.getDownupInt())));
        tmp2.add(new Label("sec"));
        north.add(new Label(""),4);north.add(new Label(""),5);

        south = new Panel();
        south.setLayout(new GridLayout(1,2));
        south.add(ok=new Button("SAVE"),0);
        south.add(cancel=new Button("CANCEL"),1);

        add("North",north);
        add("South",south);

        ok.setActionCommand(ok.getLabel());
        cancel.setActionCommand(cancel.getLabel());
	ok.addActionListener(this);
	cancel.addActionListener(this);

        pt = f.getLocationOnScreen();
        dim = f.getSize();
        pt.x += dim.width/2;
        pt.y += dim.height/2;
        setLocation(pt);
        pack();
        show();
    }

    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        int loop=0, downup=0;

        if(cmd.equals(ok.getActionCommand())){
           try{
                loop=Integer.parseInt(loop_int.getText());
           }
           catch(Exception ee){
                NoticeDialog dia = new NoticeDialog(
                    parent,"Input Error",
                   "Please input Numeric value",
                    true);
                return;
           }
           try{
                downup=Integer.parseInt(downup_int.getText());
           }
           catch(Exception ee){
                NoticeDialog dia = new NoticeDialog(
                    parent,"Input Error",
                   "Please input Numeric value",
                    true);
                return;
           }
           pi.setLoopInt(loop);
           pi.setDownupInt(downup);
           if(!pi.write()){
                NoticeDialog dia = new NoticeDialog(
                    parent,"Fail to save",
                           "Check permission of the file and directory, then try again",
                    true);
                return;
           }
        }
        dispose();
    }
}

class PreferInfo {
    String fname = "modem.pref";
    int loop_int=0, downup_int=0;

    public PreferInfo(){
        try{
            BufferedReader br = new BufferedReader(new FileReader(fname));
            String line, name, data;
            int i;
            while((line=br.readLine())!=null){
                if((i=line.indexOf('\t'))>0){
                    name = line.substring(0,i);
                    data = line.substring(i+1);
                    if(name.equals("loop_int"))
                        loop_int = Integer.parseInt(data);
                    else if(name.equals("downup_int")){
                        downup_int = Integer.parseInt(data);
                    }
                }
            }
        }
        catch(Exception e){
            loop_int =5;
            downup_int = 5;
        }
    }

    public int getLoopInt(){
        return loop_int;
    }
    public int getDownupInt(){
        return downup_int;
    }

    public void setLoopInt(int i){
        if(i<0) i=0;
        loop_int = i;
    }
    public void setDownupInt(int i){
        if(i<0) i=0;
        downup_int = i;
    }

    public boolean write(){
       try{
          PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(fname,false)));
          out.println("loop_int\t"+String.valueOf(loop_int));
          out.println("downup_int\t"+String.valueOf(downup_int));
          out.flush(); out.close();
          return true;
       }
       catch(Exception e){
           return false;
       }
    }
}
